///scrMoveAllRats()
// rats keep their direction as long as possible. If the old direction is blocked a rat chooses
// a new random direction

var tx, ty, dirChosen;

with (objRat) {
    dirChosen = false;
    while (!dirChosen) {
        tx = tilex;
        ty = tiley;
        switch (direction) {
            case DIR_UP: ty--; break;
            case DIR_DOWN: ty++; break;
            case DIR_LEFT: tx--; break;
            case DIR_RIGHT: tx++; break;
        }
        if (tx < 0 || ty < 0 || tx > TILES_X-1 || ty > TILES_Y-1) {
            // out of the maze borders
            direction = choose(DIR_UP, DIR_DOWN, DIR_LEFT, DIR_RIGHT);
        } else {
            if (Tiles[tx, ty] == TILE_EARTH) {
                // can't move here. not empty. choose a new direction
                direction = choose(DIR_UP, DIR_DOWN, DIR_LEFT, DIR_RIGHT);
            } else {
                // yeah, valid direction. Let's move this rat.
                dirChosen = true;
//                debug("rat with id " + string(id) + " shall move to " + string(tx) + ", " + string(ty) + "!");
                switch (direction) {
                    case DIR_UP: sprite_index = sprRatWalkUp; break;
                    case DIR_DOWN: sprite_index = sprRatWalkDown; break;
                    case DIR_LEFT: sprite_index = sprRatWalkLeft; break;
                    case DIR_RIGHT: sprite_index = sprRatWalkRight; break;
                }
                moving = true;
                targetx = tx;
                targety = ty;
                speed = 4;
                image_speed = 0.5;
            }
        }
    }
}
